package fr.eurecom.ratcom;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;

import fr.eurecom.ratcom.email.ReadEmailDeamon;
import fr.eurecom.ratcom.gui.RatcomAlertClient;
import fr.eurecom.ratcom.gui.RatcomAlertServer;
import fr.eurecom.ratcom.multicast.KeepAliveMulticast;
import fr.eurecom.ratcom.multicast.Multicast;
import fr.eurecom.ratcom.properties.ProjectProperties;
import fr.eurecom.ratcom.util.Logging;
import fr.eurecom.ratcom.vrsu.VirtualRoadSideThread;

import javax.swing.UIManager;

public class Server implements Ratcom {

	JFrame mainFrame = null;

	static ProjectProperties properties = ProjectProperties.getInstance();

	private static Multicast multicastServer;

	static Logging logging = Logging.getLogger();// ("smsLog.txt");

	RatcomAlertServer ratcomAlertServer = new RatcomAlertServer();

	ReadEmailDeamon readEmail;

	KeepAliveMulticast keepAliveMulticast;

	public Server() {
		mainFrame = initWindow();
		mainFrame.setVisible(true);
	}

	int nReceivedMessages = 0;

	public void showNewMessage(String msg, int id) {

		if (!mainFrame.isVisible()) {
			mainFrame.setVisible(true);
		}
		ratcomAlertServer.setAlert(msg, id);
		logging.logln("Ratcom Server: new msg: " + msg);
	}

	public void showEmptyMessage() {
		ratcomAlertServer.receivedKeepAlive();
		logging.logln("Ratcom Server: empty msg");
	}

	public JFrame initWindow() {
		JFrame frame = new JFrame();
		frame.setSize(1000, 640);
		frame.setLocation(100, 100);
		ratcomAlertServer = new RatcomAlertServer();
		ratcomAlertServer.setBackground(UIManager.getColor("Button.shadow"));
		frame.getContentPane().add(ratcomAlertServer);
		logging.logln("Ratcom Server: Init ");

		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent evt) {
				ratcomAlertServer.toPreferences();
				properties.saveParameters();
				logging.logln("Ratcom Client: Exit ");
				System.exit(0);
			}
		});

		frame.setVisible(true);
		return frame;

	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Server server = new Server();
		multicastServer = new Multicast();

		// starts the read mail thread
		server.readEmail = new ReadEmailDeamon(multicastServer, server);
		server.readEmail.start();

		// starts the keep alive message process to maintain the multicast
		KeepAliveMulticast keepAlive = new KeepAliveMulticast(multicastServer,
				server);
		keepAlive.start();
		// server.keepAliveMulticast = keepAlive;
		// server.keepAliveMulticast.start();

		if (properties.startVRSU) {
			server.enableVRSU();
		}

	}

	VirtualRoadSideThread vRSU;

	public void enableVRSU() {
		if (vRSU == null) {
			vRSU = new VirtualRoadSideThread(this);
			vRSU.start();
		}
	}

	public void disaleVRSU() {
		// vRSU.stop();
		vRSU = null;
	}

}
