package fr.eurecom.ratcom.gui;

import com.jeta.forms.components.image.ImageComponent;
import com.jeta.forms.components.line.HorizontalLineComponent;
import com.jeta.open.i18n.I18NUtils;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

import fr.eurecom.ratcom.gui.RatcomAlertServer.ShowButtonThread;
import fr.eurecom.ratcom.properties.ProjectProperties;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Properties;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.border.Border;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.border.BevelBorder;

public class RatcomAlertClient extends JPanel {
    static ProjectProperties properties = ProjectProperties.getInstance();
    JButton dismissAlert = new JButton();
    ImageComponent alertReceivedButton = new ImageComponent();
    ImageComponent msgReceivedButton = new ImageComponent();
    ImageComponent imagecomponent1 = new ImageComponent();
    ImageComponent imagecomponent2 = new ImageComponent();
    JLabel title = new JLabel();
    HorizontalLineComponent horizontallinecomponent1 = new HorizontalLineComponent();
    JLabel enablevRSULabel = new JLabel();
    JCheckBox enablevRSUCheck = new JCheckBox();
    JTextArea alertArea = new JTextArea();
    JLabel messages = new JLabel();
    Graphics g = null;

    /**
     * Default constructor
     */
    public RatcomAlertClient() {
        initializePanel();
        g = this.getGraphics();
        setOpaque(false);
    }

    @Override
    protected void paintComponent(Graphics grphcs) {
        Graphics2D g2d = (Graphics2D) grphcs;
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                RenderingHints.VALUE_ANTIALIAS_ON);

        GradientPaint gp = new GradientPaint(0, 0, getBackground().brighter()
                .brighter(), 0, getHeight(), getBackground().darker().darker());

        g2d.setPaint(gp);
        g2d.fillRect(0, 0, getWidth(), getHeight());

        super.paintComponent(grphcs);
    }

    public void cleanFields() {
        alertArea.setText("");
        messages.setText("");
    }

    /**
     * Main method for panel
     *
     * @throws InterruptedException
     */
    public static void main(String[] args) throws InterruptedException {
        JFrame frame = new JFrame();
		frame.setSize(900, 600);
        frame.setLocation(100, 100);
        RatcomAlertClient cl = new RatcomAlertClient();
        cl.setOpaque(true);
        frame.setContentPane(cl);
        frame.setVisible(true);
        for (int i = 0; i < 100; i++) {
            Thread.sleep(1000);
           cl.setAlert(i + ": msg", i);
        }
        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt) {
                System.exit(0);
            }
        });
    }

    /**
     * Adds fill components to empty cells in the first row and first column of
     * the grid. This ensures that the grid spacing will be the same as shown in
     * the designer.
     *
     * @param cols
     *            an array of column indices in the first row where fill
     *            components should be added.
     * @param rows
     *            an array of row indices in the first column where fill
     *            components should be added.
     */
    void addFillComponents(Container panel, int[] cols, int[] rows) {
        Dimension filler = new Dimension(10, 10);

        boolean filled_cell_11 = false;
        CellConstraints cc = new CellConstraints();
        if (cols.length > 0 && rows.length > 0) {
            if (cols[0] == 1 && rows[0] == 1) {
                /** add a rigid area */
                panel.add(Box.createRigidArea(filler), cc.xy(1, 1));
                filled_cell_11 = true;
            }
        }

        for (int index = 0; index < cols.length; index++) {
            if (cols[index] == 1 && filled_cell_11) {
                continue;
            }
            panel.add(Box.createRigidArea(filler), cc.xy(cols[index], 1));
        }

        for (int index = 0; index < rows.length; index++) {
            if (rows[index] == 1 && filled_cell_11) {
                continue;
            }
            panel.add(Box.createRigidArea(filler), cc.xy(1, rows[index]));
        }

    }

    /**
     * Helper method to load an image file from the CLASSPATH
     *
     * @param imageName
     *            the package and name of the file to load relative to the
     *            CLASSPATH
     * @return an ImageIcon instance with the specified image file
     * @throws IllegalArgumentException
     *             if the image resource cannot be loaded.
     */
    public ImageIcon loadImage(String imageName) {
        try {

            ClassLoader classloader = getClass().getClassLoader();
            java.net.URL url = classloader.getResource(imageName);
            if (url != null) {
                ImageIcon icon = new ImageIcon(url);
                return icon;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        throw new IllegalArgumentException(properties.loadImageException + imageName);
    }

    /**
     * Method for recalculating the component orientation for right-to-left
     * Locales.
     *
     * @param orientation
     *            the component orientation to be applied
     */
    public void applyComponentOrientation(ComponentOrientation orientation) {
        // Not yet implemented...
        // I18NUtils.applyComponentOrientation(this, orientation);
        super.applyComponentOrientation(orientation);
    }

    public JScrollPane createPanel() {
        // JPanel jpanel1 = new GradientPanel(GradientPanel.VERTICAL);
        // jpanel1.setBackground(new Color(69, 183, 223));
        JPanel jpanel1 = new JPanel() {
            @Override
            protected void paintComponent(Graphics grphcs) {
                Graphics2D g2d = (Graphics2D) grphcs;
                g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                        RenderingHints.VALUE_ANTIALIAS_ON);

                GradientPaint gp = new GradientPaint(0, 100, new Color(192,
                        208, 255), 0, getHeight(), new Color(58, 125, 249));
                // GradientPaint gp = new GradientPaint(0, 100,
                // getBackground().brighter().brighter(), 0, getHeight(),
                // getBackground().darker());
                // GradientPaint gp = new GradientPaint(0, 100,
                // new Color(170, 221, 238), 0, getHeight(),
                // new Color(68, 102, 221));

                g2d.setPaint(gp);
                g2d.fillRect(0, 0, getWidth(), getHeight());

                super.paintComponent(grphcs);
            }
        };
        jpanel1.setOpaque(false);
        JScrollPane jscrollpane1 = new JScrollPane();
        jscrollpane1.setViewportView(jpanel1);
        jscrollpane1
                .setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
        jscrollpane1
                .setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        // FormLayout formlayout1 = new
        // FormLayout("FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(0.5),FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE,CENTER:31PX:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:GROW(1.0),CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
        FormLayout formlayout1 = new FormLayout(
                "FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:8DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE",
                "CENTER:DEFAULT:NONE,CENTER:31PX:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:MAX(250PX;DEFAULT):NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
        CellConstraints cc = new CellConstraints();
        jpanel1.setLayout(formlayout1);

        dismissAlert.setActionCommand(properties.dismissAlertButton);
        dismissAlert.setBackground(new Color(204, 204, 204));
        dismissAlert.setName("dismissAlert");
        dismissAlert.setRolloverEnabled(true);
        dismissAlert.setText(properties.dismissAlertButton);
        BevelBorder bevelborder1 = new BevelBorder(BevelBorder.RAISED, null,
                null, null, null);
        dismissAlert.setBorder(bevelborder1);
        dismissAlert.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                alertArea.setText("");
            }

        });
        jpanel1.add(dismissAlert, cc.xy(16, 13));
        alertReceivedButton.setIcon(loadImage(properties.unabledStatusButton));
        alertReceivedButton.setName("centerStatusButton");
        EtchedBorder etchedborder1 = new EtchedBorder(EtchedBorder.RAISED,
                null, null);
        Border border1 = BorderFactory.createTitledBorder(etchedborder1,
        		properties.alertButtonTitle, TitledBorder.DEFAULT_JUSTIFICATION,
                TitledBorder.DEFAULT_POSITION, null, new Color(204,204,204));
        alertReceivedButton.setBorder(border1);
        jpanel1.add(alertReceivedButton, cc.xy(12, 13));

        msgReceivedButton.setIcon(loadImage(properties.unabledStatusButton));
        msgReceivedButton.setName("leftStatusButton");
        EtchedBorder etchedborder2 = new EtchedBorder(EtchedBorder.RAISED,
                null, null);
        Border border2 = BorderFactory.createTitledBorder(etchedborder2, properties.receivedButtonLabel,
                TitledBorder.DEFAULT_JUSTIFICATION,
                TitledBorder.DEFAULT_POSITION, null, new Color(204,204,204));
        msgReceivedButton.setBorder(border2);
        jpanel1.add(msgReceivedButton, cc.xy(10, 13));

        imagecomponent1.setIcon(loadImage(properties.ratcomLogo));
        EtchedBorder etchedborder3 = new EtchedBorder(EtchedBorder.LOWERED,
                null, null);
        imagecomponent1.setBorder(etchedborder3);
        jpanel1.add(imagecomponent1, cc.xy(8, 13));

        imagecomponent2.setIcon(loadImage(properties.eurecomLogo));
        EtchedBorder etchedborder4 = new EtchedBorder(EtchedBorder.LOWERED,
                null, null);
        imagecomponent2.setBorder(etchedborder4);
        jpanel1.add(imagecomponent2, cc.xy(6, 13));

        title.setFont(new Font("Serif", Font.BOLD, 20));
        title.setForeground(new Color(0, 0, 102));
        title.setName("title");
        title.setText(properties.clientTitle);
        jpanel1.add(title, cc.xywh(2, 2, 13, 1));

        jpanel1.add(horizontallinecomponent1, cc.xywh(2, 3, 16, 1));

        alertArea.setEditable(false);
        alertArea.setEnabled(false);
        alertArea.setName("alertArea");
        alertArea.setMinimumSize(new Dimension(400, 300));
		alertArea.setForeground(new Color(157,9,9));
		alertArea.setDisabledTextColor(new Color(157,9,9));
       EtchedBorder etchedborder5 = new EtchedBorder(EtchedBorder.LOWERED,
                null, null);
        Border border3 = BorderFactory.createTitledBorder(etchedborder5,
        		properties.alertFieldTitle, TitledBorder.DEFAULT_JUSTIFICATION,
                TitledBorder.DEFAULT_POSITION, null, new Color(49, 106, 196));
        alertArea.setBorder(border3);
        JScrollPane jscrollpane2 = new JScrollPane();
        jscrollpane2.setViewportView(alertArea);
        jscrollpane2
                .setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
        jscrollpane2
                .setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        jpanel1.add(jscrollpane2, cc.xywh(2, 5, 16, 5));


        messages.setBackground(new Color(255, 255, 255));
        messages.setForeground(new Color(255, 255, 255));
        messages.setText(properties.initialTextAtMessages);
        EtchedBorder etchedborder6 = new EtchedBorder(EtchedBorder.RAISED,
                null, null);
        Border border4 = BorderFactory.createTitledBorder(etchedborder6,
                properties.receivedMsgsSeparator, TitledBorder.DEFAULT_JUSTIFICATION,
                TitledBorder.DEFAULT_POSITION, null, new Color(0, 49, 139));
        messages.setBorder(border4);
        jpanel1.add(messages, cc.xywh(2, 15, 16, 1));

        enablevRSULabel.setName("enablevRSULabel");
        enablevRSULabel.setText(properties.enablevRSULabel);
        jpanel1.add(enablevRSULabel, cc.xy(3, 11));

        enablevRSUCheck.setBackground(new Color(255, 255, 255));
        enablevRSUCheck.setName("enablevRSUCheck");
        enablevRSUCheck.setSelected(true);
        EtchedBorder etchedborder7 = new EtchedBorder(EtchedBorder.RAISED,
                null, null);
        enablevRSUCheck.setBorder(etchedborder7);
        enablevRSUCheck.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                properties.startVRSU = enablevRSUCheck.isSelected();
            }

        });
        jpanel1.add(enablevRSUCheck, cc.xy(4, 11));

        addFillComponents(jpanel1, new int[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10,
                11, 12, 13, 14, 15, 16, 17, 18 }, new int[] { 1, 2, 3, 4, 5, 6,
                7, 8, 9, 10, 11, 12, 13, 14, 15, 16 });
        return jscrollpane1;
    }

    /**
     * Initializer
     */
    protected void initializePanel() {
        setLayout(new BorderLayout());
        add(createPanel(), BorderLayout.CENTER);
    }

	ShowButtonThread sb1;
	ShowButtonThread sb2;
	ShowButtonThread sb3;
	int keepAlive = 0;

	/**
	 * @param msg
	 * 
	 * @date Dec 5, 2010 - 11:09:15 PM : daniel
	 */
	public void receivedKeepAlive() {
		messages.setText(properties.msgKeepAlive + ++keepAlive
				+ properties.msgLastMsgRec + msgNumber);
		sb3 = new ShowButtonThread(msgReceivedButton,
				properties.recMessageButton);
	}

	int msgNumber = 0;

	/**
	 * @param msg
	 * 
	 * @date Dec 5, 2010 - 11:09:15 PM : daniel
	 */
	public void setAlert(String msg, int msgNumber) {
		this.msgNumber = msgNumber;
		alertArea.append(properties.alertMsgHeadrInit + msgNumber +
				properties.alertMsgHeadrEnd + msg + "\n");
        alertArea.setCaretPosition(alertArea.getText().length());
		messages.setText(properties.msgKeepAlive + keepAlive
				+ properties.msgLastMsgRec + msgNumber);
		sb1 = new ShowButtonThread(msgReceivedButton,
				properties.recMessageButton);
		sb2 = new ShowButtonThread(alertReceivedButton,
				properties.recAlertButton);
	}
	
	
    /**
     *
     * Ratcom <br>
     *
     * @file gui.RatcomAlertClient.java
     * @author daniel
     * @date Dec 5, 2010 - 11:39:45 PM
     */
    class ShowButtonThread implements Runnable {

        ImageComponent statusButton;
        String newImage;
        RatcomAlertClient componentToChange;

        Thread runner;

		public ShowButtonThread() {
		}

		public ShowButtonThread(ImageComponent statusButton, String newImage) {
			runner = new Thread(this, "changeButton"); // (1) Create a new
			// thread.
			this.statusButton = statusButton;
			this.newImage = newImage;
			runner.start(); // (2) Start the thread.
		}

		public void run() {
			// Icon originalImage = statusButton.getIcon();
			statusButton.setIcon(loadImage(newImage));
			repaint();
			try {
				runner.sleep(800);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			statusButton.setIcon(loadImage(properties.unabledStatusButton));
			repaint();
		}
	}

}