/**
 * Ratcom <br>
 * Copyright (c) 2008,  <br>
 * All rights reserved.<br>
 * The authors reserve all rights over the content of this file<br>
 * Any use\copy\alteration of it must be authorized by the authors<br> 
 * 
 * @date 16 oct. 08 - 21:23:42 
 * @author Daniel_2
 */
package fr.eurecom.ratcom.properties;
import java.net.SocketAddress;
import java.util.Properties;

import org.w3c.dom.NodeList;

import fr.eurecom.ratcom.xml.XMLAlertParser;

/**
 * Ratcom <br>
 *
 * This class stores and handles the greatest part of the properties used here.
 * Changes of the values should be done in the .properties file. To create a 
 * new property just create the variable here and the class will take care of 
 * every thing else.
 *
 * @file properties.ProjectProperties.java
 * @author Daniel_2
 * @date 16 oct. 08 - 21:23:42 
 */
public class ProjectProperties extends Properties {

    public static String newline = System.getProperty("line.separator");
  

	private static ProjectProperties p;

    public String parametersFileName = "system.properties";

	public String NoMessageFoundError = newline + " *** No registered alert message was found!!! ***"+newline;
    
    // Alert E-mail configuration variables.
    public String host = "imap.gmail.com" ; //"cyrus.eurecom.fr"; //imap.gmail.com
    public int port = 993;
    public int startMailIndex = 0;
    public String username = "ratcom.test@gmail.com"; //"ratcom"; //ratcom.test@gmail.com
    public String password = "eurecom_ratcom"; //"imp1u:bem";//eurecom_ratcom
    public String folder = "INBOX";
    
	public boolean debugMode = false;

    // Multicast configuration values
	public int multicastPort = 5555; // Listening port for the Alert application
	public String multicastGroup = "232.0.0.2";// group multicast for the Alert application

	public int multicastTTL = 255; //Time to Live value,default is the maximum

	public String emailThreadName = "email_thread";

	public long sleepingTimeEmailReading = 10; // time (s) to wait until read the e-mail again

	public int keepAliveMsg = 60; // time (s) to wait until read the e-mail again;

	public int vRSU_Port = 8888;

	public String vRSU_BroadcastIP = "255.255.255.255";

	public String vrsuThreadName = "VRSU_THREAD";

	public String ID_Separator = ":";

	public String vRSU_Identifier = "V_RSU";

	public int vRSU_rebroadcastTimes = 2;

	public int vRSU_maxInterval = 1000*60; // the maximal time (ms) a vRSU should 
	                                       // wait to rebroadcast the alert message

	public boolean startVRSU = true;

	public boolean outputToConsole = true;

	public String logFileName = "ratcom.log";

	public boolean eagerLogFlush=true; // flush messages

	public String logFileDirectory = "";

	public boolean logToTimeDirectory=true;

	public String projectName = "Ratcom";

	public boolean logOn=true; // enables the log

	public String unabledStatusButton = "images/grey_30.png";

	public String ratcomLogo = "images/ratcom_logo.png";

	public String eurecomLogo = "images/eurecom_logo.png";

	public String recMessageButton = "images/green_30.png";

	public String recAlertButton = "images/red_30.png";

	public String clientTitle ="RATCOM - Alert System Client";

	public String receivedMsgsSeparator = "Messages";

	public String enablevRSULabel="Enable vRSU alerts: ";

	public String loadImageException = "Unable to load image: ";

	public String dismissAlertButton ="  Dismiss old alerts  ";

	public String alertFieldTitle = "Alert messages";

	public String receivedButtonLabel="Rx";

	public String alertButtonTitle="Alert";

	public String initialTextAtMessages ="Messages";

	public String msgKeepAlive = "Keep alive: ";

	public String msgLastMsgRec = " / Last Alert received: ";

	public String alertMsgHeadrInit = newline+ " **** Message ";

	public String alertMsgHeadrEnd = " ****"+newline;

	public String serverTitle="RATCOM - Alert System Server";

	public String msgTabTitle="Info";

	public String configTabTitle="Config";	

	public String timersConfSeparator="Timers";

	public String emailRefreshTimeLabel="Email refresh time (secs):";

	public String multicastKeepAliveLabel="Multicast keep alive message (secs):";

	public String imapServerLabel="IMAP server:";

	public String emailLabel="e-mail:";

	public String passwordLabel="Password: ";

	public String portLabel="Port:";

	public String multicastAddressLabel="Multicast address:";

	public String multicastPortLabel="Multicast port:";

	public String alertServerSeparator="Alert server";

	public String multicastSeparator="Multicast";

	public String updatePropertiesButton="Update preferences";

	public String vRSUSeparator="Virtual Road Side Unit (vRSU)";

	public String vRSUPortLabel="Port:";

	public String RSUnRebroadcastsLabel="Number of rebroadcasts/server:";

	public String RSUMaxRebIntervalLabel="Maximum rebroadcast interval:";

	public String keepAliveThreadName = "KeepAliveThread";

	public String alertMsgStart = "Alert";

	public String xmlTestFile1="xmlschemas/Exemple_detection.xml";
	public String xmlTestFile2="xmlschemas/Exemple_evolution.xml";
	public String xmlTestFile3="xmlschemas/Exemple_hauteur_eau_new.xml";
	public String xmlTestFile4="xmlschemas/Exemple_impact_new.xml";
	public String xmlTestFile5="xmlschemas/Exemple_manuel.xml";
	public String xmlTestFile6="xmlschemas/Exemple_seisme_new.xml";
	public String xmlSchemaFile="xmlschemas/RATCOM_SP2_Alertes_Draft3.xsd";

	public String waterLevelMsg ="bulletin_information_hauteur_eau";
	public String impactMsg ="bulletin_alerte_impact";
	public String earthquakeMsg ="bulletin_alerte_seisme";
	public String alertManualMsg="bulletin_alerte_manuel";
	public String alertDetectionMsg ="bulletin_alerte_detection";
	public String evolutionMsg ="bulletin_information_evolution";
	public String finAlertMsg ="bulletin_fin_alerte";
	

	// Please,do not change the order, if a new message is added, add 
	// it in the end, the index of the vector is used to control the
	// switch where the messages are identified
	public String validMessages[]={
			earthquakeMsg, 
			alertManualMsg, 
			alertDetectionMsg, 
			evolutionMsg,
			impactMsg, 
		    waterLevelMsg,
		    finAlertMsg };
	
	public String alertIDkey ="/message/entete/id_message";
	
	public String startID="/message/donnees/";
	public String latitudeID="coordonnees/latitude";
	public String longitudeID="coordonnees/longitude";
	public String detectionID="detection";
	public String detectionCapteurID=detectionID + "capteur";
	public String nameID="nom";
	public String typeID="type";
	public String waveHighID="hauteur_vague";
	public String dateArrivalID="date_arrivee";
	public String importanceID="criticite";
	public String dateDetectionID="date_detection";
	public String WaterLevelID="hauteur_eau";
	
	public String latLabel=newline + "Latitude: ";
	public String longLabel=newline + "Longitude: ";
	public String nameLabel=newline + "Name: ";
	public String waveHeightLabel=newline + "Wave size: ";
	public String impactDateLabel=newline + "Forecast arriving date: ";
	public String impactImpLevelLabel=newline + "Importance level: ";

	public String waterLevelLabel=newline + "Water level: ";

	public String confidenceLevelLabel=newline + "Confidence: ";

	public String messageLabel=newline + "Message: ";
	public String sensorNameLabel=newline + "Sensor name: ";
	public String sensorTypeLabel=newline + "Sensor type: ";

	public String pointID ="point";
	public String capteurID ="capteur/";
	public String points ="/points/"+ pointID;
	public String detections ="/detections/detection";
	public String impactPoints ="/impact_cote/"+ pointID;
	public String confIndexID = "/indice_confiance";
	

	public String alertMessageEarthquake=startID + earthquakeMsg + "/seisme/commentaire";
	
	public String alertMessageManuelComment=startID + alertManualMsg + "/commentaires";
	public String alertMessageManuelConfidence=startID + alertManualMsg + confIndexID;

	public String detectionMainID=startID + alertDetectionMsg;
	public String detectionListID=startID + alertDetectionMsg + detections;
	public String evolutionMainID=startID + evolutionMsg;
	public String evolutionListID=startID + evolutionMsg + detections;

	public String detectionLabels [] = {latLabel,longLabel, impactDateLabel, waterLevelLabel,sensorNameLabel, sensorTypeLabel};
	public String detectionIDs [] = {capteurID+latitudeID,capteurID+longitudeID, dateDetectionID, WaterLevelID, capteurID+nameID, capteurID+typeID};

	public String impactMainID=startID + impactMsg;
	public String impactListID=startID + impactMsg + impactPoints;
	public String waterMainID=startID + waterLevelMsg;
	public String waterLevelListID=startID + waterLevelMsg  + points;
	
	public String pointLabels [] = {latLabel,longLabel, impactDateLabel, waveHeightLabel,sensorNameLabel, impactImpLevelLabel};
	public String pointIDs [] = {latitudeID,longitudeID, dateArrivalID, waveHighID, nameID, importanceID};


	public boolean removeEmail=false;
    /**
     * Singleton class, this means that all classes
     * that ask for one property will receive the same instance
     * if one class change the property all other classes
     * will see the same information
     */
    private ProjectProperties(){
      p = (ProjectProperties) HandleProperties.loadParameters("system.properties", this);
      newline = System.getProperty("line.separator");
    }
    
    public static ProjectProperties getInstance(){
      if(p==null)
        new ProjectProperties();
       return p;
    }
    
    public static boolean saveParameters(){
      boolean Ok = HandleProperties.saveProperties(p.parametersFileName,p);
      
      return Ok;
    }

    public static void main(String[] args) {
     ProjectProperties p = ProjectProperties.getInstance();
      boolean Ok = HandleProperties.saveProperties("system.properties",p);
      System.out.print(Ok);

    }

}
