package fr.eurecom.ratcom.vrsu;

import java.util.Random;

import fr.eurecom.ratcom.util.Logging;
import fr.eurecom.ratcom.util.StringHandler;

public class RebroadcastAlert extends Thread {
	String msg;
	int msgID;
	int times; 
	int maxInterval;
	Logging logging = Logging.getLogger();// ("smsLog.txt");

	
	public RebroadcastAlert(String msg, int msgID, int times, int maxInterval){
		super();
		this.msg = msg;  
		this.msgID = msgID;
		this.times=times; 
		this.maxInterval=maxInterval;
		
	}
	
	public void run() {
		int sentTimes = 0;
		Random rand = new Random();
		// just to avoid colision
		try {
			sleep(rand.nextInt(2000));
		} catch (InterruptedException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		while (sentTimes<times) {
			try {
//				VirtualRoadSideUnitNet.sendMessage(msg, msgID);
				VirtualRoadSideUnitNet.sendOverAllInterfaces(msg, msgID);
				logging.logln("vRSU rebroadcast msg "+ msgID+" " +(sentTimes+1) + "/"+times);
				int waitInterval = rand.nextInt(maxInterval); // wait in msg
				sleep(waitInterval);
			} catch (Exception e) {
				logging.logln("vRSU rebroadcast problems with the socket -> "
						+ e.getMessage());
				e.printStackTrace();
			}
			sentTimes++;
		}
		logging.logln("vRSU rebroadcast "+ msgID+" exit");
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}
