/**
 * ConferencesPage <br>
 * Copyright (c) 2008,  <br>
 * All rights reserved.<br>
 * The authors reserve all rights over the content of this file<br>
 * Any use\copy\alteration of it must be athorized by the authors<br> 
 * 
 * @date 17 oct. 08 - 23:52:29 
 * @author Daniel Camara - danielcamara@gmail.com
 */
package fr.eurecom.ratcom.xml;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import fr.eurecom.ratcom.xml.XMLData;


/**
 * ConferencesPage <br>
 *
 * @file xml.MetaInformation.java
 * @author Daniel_2
 * @date 17 oct. 08 - 23:52:29 
 */
public class MetaInformation extends XMLData{
//http://java.sun.com/developer/technicalArticles/xml/validationxpath/
	private String conferenceName;
	private String conferenceDeadLine;
	private String place;
	private String conferenceDate;
	private String from;
	private String receivedDate;
	private String subject;
	private String fileToTheCallText;
	private boolean extendedDeadline;
	private int correctInfo;

	/**
	 * @param conferenceName
	 * @param conferenceDeadLine
	 * @param place
	 * @param conferenceDate
	 * @param from
	 * @param receivedDate
	 * @param subject
	 * @param fileToTheCallText
	 * @param extendedDeadline
	 * @param correctInfo
	 * @date 18 oct. 08 - 00:09:49 : Daniel_2
	 */
	public MetaInformation(String conferenceName, String conferenceDeadLine,
			String conferenceDate, String place, String from,
			String receivedDate, String subject, String fileToTheCallText,
			boolean extendedDeadline, int correctInfo) {
		super();
		this.conferenceName = conferenceName;
		this.conferenceDeadLine = conferenceDeadLine;
		this.place = place;
		this.conferenceDate = conferenceDate;
		this.from = from;
		this.receivedDate = receivedDate;
		this.subject = subject;
		this.fileToTheCallText = fileToTheCallText;
		this.extendedDeadline = extendedDeadline;
		this.correctInfo = correctInfo;
	}
	
	/**
	 * Default public constructor just for test and get methods reason
	 * Should not be used for store real data.
	 * 
	 * @date 19 oct. 08 - 11:22:12 : Daniel_2
	 */
	public MetaInformation() {
		this.conferenceName = "";
		this.conferenceDeadLine = "";
		this.place = "";
		this.conferenceDate = "";
		this.from = "";
		this.receivedDate = "";
		this.subject = "";
		this.fileToTheCallText = "";
		this.extendedDeadline = false;
		this.correctInfo = -1;
	}
	
	/**
	 * Helper method which creates a XML element <Book>
	 * @param simulationData The book for which we need to create an xml representation
	 * @return XML element snippet representing a book
	 */
	public Element createData(Document dom){

		Element simulationElement = dom.createElement("CFP");
		
		createElement(dom, simulationElement, "ConferenceName", 
				getConferenceName());

		createElement(dom,simulationElement, "ConferenceDate", 
				getConferenceDate());
		
		createElement(dom,simulationElement, "ConferenceDeadLine", 
				getConferenceDeadLine());

		createElement(dom,simulationElement, "Place", 
				getPlace());

		createElement(dom,simulationElement, "ReceivedDate", 
				getReceivedDate());

		createElement(dom,simulationElement, "From", 
				getFrom());
		
		createElement(dom,simulationElement, "Subject", 
				getSubject());

		createElement(dom,simulationElement, "FileToTheCallText", 
				getFileToTheCallText());

		createElement(dom,simulationElement, "ExtendedDeadline", 
				getExtendedDeadline()+"");

		createElement(dom,simulationElement, "CorrectInfo", 
				getCorrectInfo()+"");
		
		return simulationElement;

	}

	/**
	 * I take a SimulationData element and read the values in, create an
	 * SimulationData object and return it
	 * 
	 * @param element
	 * @return
	 */
	public XMLData getData(Element element) {

		String conferenceName = getTextValue(element, "ConferenceName"); 
		String conferenceDate = getTextValue(element, "ConferenceDate"); 
		String conferenceDeadLine = getTextValue(element, "ConferenceDeadLine"); 
		String place = getTextValue(element, "Place"); 
		String receivedDate = getTextValue(element, "ReceivedDate"); 
		String from = getTextValue(element, "From"); 
		String subject = getTextValue(element, "Subject"); 
		String fileToTheCallText = getTextValue(element, "FileToTheCallText"); 
		boolean extendedDeadline = getboolValue(element, "ExtendedDeadline"); 
		int correctInfo = getIntValue(element, "CorrectInfo"); 

		// Create a new Simulation Data with the value read from the xml nodes
		MetaInformation metaInformation = new MetaInformation(
				conferenceName, conferenceDeadLine,
				conferenceDate, place, from,
				receivedDate, subject, fileToTheCallText,
				extendedDeadline, correctInfo);

		return metaInformation;
	}

	public String getConferenceName() {
		return conferenceName;
	}



	public void setConferenceName(String conferenceName) {
		this.conferenceName = conferenceName;
	}



	public String getConferenceDeadLine() {
		return conferenceDeadLine;
	}



	public void setConferenceDeadLine(String conferenceDeadLine) {
		this.conferenceDeadLine = conferenceDeadLine;
	}



	public String getPlace() {
		return place;
	}



	public void setPlace(String place) {
		this.place = place;
	}



	public String getConferenceDate() {
		return conferenceDate;
	}



	public void setConferenceDate(String conferenceDate) {
		this.conferenceDate = conferenceDate;
	}



	public String getFrom() {
		return from;
	}



	public void setFrom(String from) {
		this.from = from;
	}



	public String getReceivedDate() {
		return receivedDate;
	}



	public void setReceivedDate(String receivedDate) {
		this.receivedDate = receivedDate;
	}



	public String getSubject() {
		return subject;
	}



	public void setSubject(String subject) {
		this.subject = subject;
	}



	public String getFileToTheCallText() {
		return fileToTheCallText;
	}



	public void setFileToTheCallText(String fileToTheCallText) {
		this.fileToTheCallText = fileToTheCallText;
	}



	public boolean getExtendedDeadline() {
		return extendedDeadline;
	}



	public void setExtendedDeadline(boolean extendedDeadline) {
		this.extendedDeadline = extendedDeadline;
	}



	public int getCorrectInfo() {
		return correctInfo;
	}



	public void setCorrectInfo(int correctInfo) {
		this.correctInfo = correctInfo;
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("conferenceName = " + conferenceName);
		sb.append("conferenceDeadLine = " + conferenceDeadLine);
		sb.append("place = " + place);
		sb.append("conferenceDate = " + conferenceDate);
		sb.append("from = " + from);
		sb.append("receivedDate = " + receivedDate);
		sb.append("subject = " + subject);
		sb.append("fileToTheCallText = " + fileToTheCallText);
		sb.append("extendedDeadline = " + extendedDeadline);
		sb.append("correctInfo = " + correctInfo);
		return sb.toString();
	}

	/**
	 * @param args
	 *
	 * @date 17 oct. 08 - 23:52:29 : Daniel_2
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}
