/**
 * Ratcom <br>
 * Copyright (c) 2008,  <br>
 * All rights reserved.<br>
 * The authors reserve all rights over the content of this file<br>
 * Any use\copy\alteration of it must be athorized by the authors<br> 
 * 
 * @date 19 oct. 08 - 10:24:19 
 * @author Daniel Camara - danielcamara@gmail.com
 */
package fr.eurecom.ratcom.xml;

import java.lang.reflect.Array;
import java.util.ArrayList;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * Ratcom <br>
 *
 * @file xml.XMLData.java
 * @author Daniel_2
 * @date 19 oct. 08 - 10:24:19 
 */
public abstract class XMLData {
public abstract Element createData(Document dom) ;
public  abstract  XMLData getData(Element element);

protected  void createElement(Document dom, Element simulationElement, String elementName, 
		String simulationData) {
	
	Element element = dom.createElement(elementName);
	element.setTextContent(simulationData);
	simulationElement.appendChild(element);
}
/**
 * This method takes a xml element and the tag name, look for the tag and get the text
 * content i.e for <employee><name>John</name></employee> xml snippet if
 * the Element points to employee node and tagName is name it will return John  
 * @param ele
 * @param tagName
 * @return
 */
protected String getTextValue(Element ele, String tagName) {
	String textVal = "";
	NodeList nl = ele.getElementsByTagName(tagName);
	if (nl != null && nl.getLength() > 0) {
		Element el = (Element) nl.item(0);
		if (el != null) {
			Node n = el.getFirstChild();
			if (n != null)
				textVal = n.getNodeValue();
		}
	}

	return textVal;
}

/**
 * Calls getTextValue and returns a int value
 * 
 * @param ele
 * @param tagName
 * @return
 */
protected  int getIntValue(Element ele, String tagName) {
	// in production application you would catch the exception
	return Integer.parseInt(getTextValue(ele, tagName));
}

/**
 * Calls getTextValue and returns a int value
 * 
 * @param ele
 * @param tagName
 * @return
 */
protected  float getFloatValue(Element ele, String tagName) {
	// in production application you would catch the exception
	return Float.parseFloat(getTextValue(ele, tagName));
}

/**
 * Calls getTextValue and returns a boolean value
 * 
 * @param ele
 * @param tagName
 * @return
 */
protected  boolean getboolValue(Element ele, String tagName) {
	// in production application you would catch the exception
	return Boolean.parseBoolean(getTextValue(ele, tagName));
}

protected String[] getStringArrayValues(Element ele, String tagName) {
	String stringValue = getTextValue(ele, tagName);

	return stringValue.split(";");
}

}
