package fr.eurecom.ratcom.xml;

import java.io.ByteArrayInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class XMLParser {
//http://java.sun.com/developer/technicalArticles/xml/validationxpath/
	// No generics
	Document dom;

	public XMLParser() {
	}

	public ArrayList parseString(String string, String tagName, XMLData elmentType) 
	throws ParserConfigurationException, SAXException, IOException {

		// parse the xml file and get the dom object
		parseString(string);

		// get each employee element and create a Employee object
		return parseDocument(tagName, elmentType);
	}

	public ArrayList parseFile(String fileName, String tagName, XMLData elmentType) 
	throws ParserConfigurationException, SAXException, IOException {

		// parse the xml file and get the dom object
		parseXmlFile(fileName);

		// get each employee element and create a Employee object
		return parseDocument(tagName, elmentType);
	}

	private void parseXmlFile(String file) throws FileNotFoundException, 
	ParserConfigurationException, SAXException, IOException{ 
		parseXml(new FileInputStream(file));
	}
	
	private void parseString(String s) throws UnsupportedEncodingException, 
	ParserConfigurationException, SAXException, IOException{ 
		parseXml(new ByteArrayInputStream(s.getBytes("UTF-8")));
	}

	private void parseXml(InputStream inputStream) 
	throws ParserConfigurationException, SAXException, IOException {
		// get the factory
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();

		// Using factory get an instance of document builder
		DocumentBuilder db = dbf.newDocumentBuilder();

		// parse using builder to get DOM representation of the XML file
		dom = db.parse(inputStream); 
	}
	
	private ArrayList parseDocument(String tagName, XMLData elemType) {
		// get the root elememt
		Element docEle = dom.getDocumentElement();
		ArrayList myEmpls = new ArrayList();
 
		// get a nodelist of <Scenario> elements
		NodeList nl = docEle.getElementsByTagName(tagName);
		if (nl != null && nl.getLength() > 0) {
			for (int i = 0; i < nl.getLength(); i++) {

				// get the scenario element
				Element el = (Element) nl.item(i);

				// get the scenario objects
				XMLData e = elemType.getData(el);

				// add it to list
				myEmpls.add(e);
			}
		}
		return myEmpls;
	}


	/**
	 * Iterate through the list and print the content to console
	 */
	public void printData(List myEmpls) {

		System.out.println("No of Elements '" + myEmpls.size() + "'.");

		Iterator it = myEmpls.iterator();
		while (it.hasNext()) {
			System.out.println(it.next().toString());
		}
	}

//	public static void main(String[] args) {
//		// create an instance
//		XMLParser dpe = new XMLParser();
//		List l = new ArrayList();
//		try {
//			l = dpe.parseFile("test3.xml");
//		} catch (ParserConfigurationException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} catch (SAXException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		dpe.printData(l);
//	}

}